var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

var sErrorMSG="";

function setWithRetryOneValue(deviceObj,value,bank,index,iRetry, fFehlertolerant) {
    deviceObj.setConfig(bank,index,value);
    var checkValue=deviceObj.getConfig(bank,index);
    if (fFehlertolerant==null)
        fFehlertolerant=false;
    if (!fFehlertolerant) {
        if (checkValue!=value) {
            if (iRetry>0) {
                lInfo.logln('Fehler: Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue + ' noch ' + iRetry + ' Versuche');
                return setWithRetryOneValue(deviceObj,value,bank,index,iRetry-1);
            } else {
                sErrorMSG+='Letzer Versuch: Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue ;
                lInfo.logln(sErrorMSG );
                return false;
            }
        } else {
            lInfo.logln('OK : Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue);
            return true;
        }
    }
    lInfo.logln('(vielleicht) OK : Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue);
    return true;

}

function executeSetValue(dsid,oValues,thr,cal,offset) {
    try {
    var oDevice=getDevices().byDSID(dsid);
    if (oDevice==null) {
        sErrorMSG='Gert ' + dsid + ' nicht gefunden'
        lWarn.logln(sErrorMSG);
        return false;
    }
    var iStep=0;
    var iRetry=false;
    var checkValue;
    if (setWithRetryOneValue(oDevice,22,0x3,0x0,2)==false) {
        lWarn.logln('Fehler beim Schreiben Dimmart Abbruch!');
        return false;
    }
    for (var iIndex=0;iIndex<17;iIndex++) {
        if (setWithRetryOneValue(oDevice,oValues[iIndex],0x3,0x30+iIndex,2)==false) {
            lWarn.logln('Fehler beim Schreiben Kennline Wert #' + iIndex + ' Abbruch!');
            return false;
        }
    }

    if (setWithRetryOneValue(oDevice,thr,0x4,0x28,2,true)==false) {
        lWarn.logln('Fehler beim Schreiben Kennline Wert #17 Abbruch!');        
        return false;
    }
    
    if (setWithRetryOneValue(oDevice,cal,0x4,0x29,2,true)==false) {
        lWarn.logln('Fehler beim Schreiben Kennline Wert #18 Abbruch!');        
        return false;
    }
    if (setWithRetryOneValue(oDevice,offset&0xff,0x4,0x2c,2,true)==false) {
        lWarn.logln('Fehler beim Schreiben Kennline Wert #19 Abbruch!');        
        return false;
    }
    if (setWithRetryOneValue(oDevice,offset>>8,0x4,0x2d,2,true)==false) {
        lWarn.logln('Fehler beim Schreiben Kennline Wert #20 Abbruch!');        
        return false;
    }
    
    return true;
    
    } catch (e){
        lWarn.logln('Fehler beim ExecuteSetValue ' + e);
        for (var i in e) {
            lWarn.logln(i + ': ' + e[i]);
        }
        return false;
    }
}

function programmOneOfCataloge(dsid,id,fLegal) {
    try {
        lInfo.logln('programmOneOfCataloge : dsid:' + dsid + ' id: ' + id + ' fLegal: ' +fLegal);
        var oCatalog=JSON.parse(Property.getNode('entries/' + id).getValue());
        var fExecuted=false;
        if (''+fLegal=='true') {
            fExecuted=executeSetValue(dsid,oCatalog.vals,oCatalog.THR,oCatalog.CAL,oCatalog.OFFSET);
        } else {
            fExecuted=executeSetValue(dsid,oCatalog.Evals,oCatalog.ETHR,oCatalog.ECAL,oCatalog.EOFFSET);
        }
        if (fExecuted) {
            if (id==0)
                {
                    var baseNode = Property.getNode('devices');
                    if (baseNode != null)
                        baseNode.removeChild(dsid);
                } else {
                    storeSubParameter('devices/' + dsid + '/dsid' , dsid);
                    storeSubParameter('devices/' + dsid + '/unmodifiedCataloge' , true);
                    storeSubParameter('devices/' + dsid + '/catalogeID' , id);
                    storeSubParameter('devices/' + dsid + '/legal' , fLegal);
                    if (''+fLegal=='true') {
                        storeSubParameter('devices/' + dsid + '/values' , JSON.stringify({values:oCatalog.vals,thr:oCatalog.THR,off:oCatalog.OFFSET,cal:oCatalog.CAL}));
                    } else {
                        storeSubParameter('devices/' + dsid + '/values' , JSON.stringify({values:oCatalog.Evals,thr:oCatalog.ETHR,off:oCatalog.EOFFSET,cal:oCatalog.ECAL}));
                    }
                    storeSubParameter('devices/' + dsid + '/ts' , ""+(new Date()).getTime());
                }
            return true;
        } else {
            lWarn.logln('Programmierung von ' + dsid + ' fehlgeschlagen');
            return false;
        }
            
    } catch(e) {
        lWarn.logln('Fehler beim programmOneOfCataloge' + e);
        return false;
    }
}


function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty(path, value);
        Property.setFlag(path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}

function refreshCache() 
{
    var db_data;
    var db_update;
    
    try {
        var h = new HTTP( { 'debug' : 0 }, {});
        var code = h.get("http://ds.ccweb.cc/bulbs/db2.js", '/bulbs/db2.js');
        if (code.status.valueOf() === 200) {
            lInfo.logln('OK [' + code.status + ']' + code.body);
            var oData=JSON.parse(code.body);
            var baseNode = Property.getNode('/scripts/led-wizard');
            if (baseNode != null)
                baseNode.removeChild('entries');
            for (var iIndex=0;iIndex<oData.data.length;iIndex++)
                storeSubParameter("entries/" +iIndex,JSON.stringify(oData.data[iIndex]));
            Property.setProperty('lastUpdate', oData.db_update);
            Property.setFlag('lastUpdate', 'ARCHIVE', true);
        } else {
            lWarn.logln(sString + ': FAILED! Server replied: "' + code.status + '"');
            lInfo.logln(code.body);
        }
    } catch (e) {
        lWarn.logln("Error during resyncing cache");
        for (var i in e) {
            lWarn.logln(i + ': ' + e[i]);
        }
    }

}

function setValuesFromCatalog() {
    if (raisedEvent.parameter.dsid==null) {
        new Event('led-wizard.answer',{result:false,error:'Parameter dsid fehlt'}).raise();
        lWarn.logln('Parameter dsid fehlt');
        return;
    }
    if (raisedEvent.parameter.catid==null) {
        new Event('led-wizard.answer',{result:false,error:'Parameter catid fehlt'}).raise();
        lWarn.logln('Parameter catid fehlt');
        return;
    }
    if (raisedEvent.parameter.legal==null) {
        new Event('led-wizard.answer',{result:false,error:'Parameter legal fehlt'}).raise();
        lWarn.logln('Parameter legal fehlt');
        return;
    }
    if (programmOneOfCataloge(raisedEvent.parameter.dsid,raisedEvent.parameter.catid,raisedEvent.parameter.legal)) {
        new Event('led-wizard.answer',{result:true,error:''}).raise();
        lInfo.logln('Answer Event geraised');
    } else {
        if (sErrorMSG=='')
            sErrorMSG="Es ist ein Fehler aufgetreten. Nhere Informationen stehen im LOG";
        new Event('led-wizard.answer',{result:false,error:sErrorMSG}).raise();
        lWarn.logln('Fehler sind aufgetreten');
    }
}


function startDemo(){
    if (raisedEvent.parameter.dsid==null)
        return;
    var fOngoing=true;
    if (Property.getProperty('general/demoDSID')==null)
        fOngoing=false;
    if (Property.getProperty('general/demoDSID')=='')
        fOngoing=false;
    
    Property.setProperty('general/demoDSID',raisedEvent.parameter.dsid);
    Property.setProperty('general/counter',0);
    Property.setProperty('general/step',-1);
    if (!fOngoing) {
        lInfo.logln('starte zyklus');
        makeDemo();
    } else {
        lInfo.logln('Demo luft schon');
    }
}

var iMaxStep=32;
var iMax=iMaxStep*5;

function makeDemo() {
    var deviceDSID=Property.getProperty('general/demoDSID');
    var iMaxCounter=Property.getProperty('general/counter');
    var iStep=Property.getProperty('general/step');
    if (deviceDSID==null) {
        lInfo.logln('no DemoDSID');
        return;
    } 
        
    if (deviceDSID=='') {
        lInfo.logln('no DemoDSID');
        return;
    }
        
    if (iMaxCounter>=iMax) {
        Property.setProperty('general/demoDSID','');
        lInfo.logln('Ende Aktion');
        try {
            var oDevice=getDevices().byDSID(deviceDSID);
            if (oDevice!=null) {
                oDevice.setValue(0);
            }
        } catch (e) {
        }
        return;
    }
    iStep=(iStep + Math.floor(256/iMaxStep))%256;
    Property.setProperty('general/step',iStep);
    lInfo.log('Make Step : '+ iStep + ' for ' + deviceDSID + ' Step ' + iMaxCounter + ' of ' + iMax + '\n');    
    try {
        var oDevice=getDevices().byDSID(deviceDSID);
        if (oDevice==null) {
            Property.setProperty('general/demoDSID','');
            sErrorMSG='Gert ' + deviceDSID + ' nicht gefunden';
            lWarn.logln(sErrorMSG);
            return;
        }
        oDevice.setValue(parseInt(iStep,10));
    } catch (e) {
        Property.setProperty('general/demoDSID','');
        lInfo.logln('Ende Aktion aufgrund Fehler ' + e);
        return;
    }
    Property.setProperty('general/counter',iMaxCounter+1);
    setTimeout(makeDemo,750);
}

function setManualValue() {
    try {
        var oDevice=getDevices().byDSID(raisedEvent.parameter.dsid);
        if (oDevice==null) {
            lWarn.logln('kein Device gefunden');
        }
        var oValue=parseInt(raisedEvent.parameter.value,10);
        lInfo.logln('Setze ' + raisedEvent.parameter.dsid + " auf " + oValue);
        oDevice.setValue(oValue);
    } catch(e) {
        lWarn.logln('Fehler beim SetManualValue '+ e);

    }
} 

if (raisedEvent.parameter.actions != null) {
    if (raisedEvent.parameter.actions == 'syncOnline') {
        refreshCache();
        Property.store();
    }
	if (raisedEvent.parameter.actions == "save") {
		Property.store();
	}
	if (raisedEvent.parameter.actions == "load") {
		Property.load();
	}
	if (raisedEvent.parameter.actions == 'setValuesFromCatalog') {
	    Property.setProperty('general/demoDSID','');
	    setValuesFromCatalog();	    
	    Property.store();
	}
	if (raisedEvent.parameter.actions == 'startDemoModus') {
	    lInfo.log('Start Demo');    
	    startDemo();
	}
	if (raisedEvent.parameter.actions == 'setValue') {
	    setManualValue();
	}
	if (raisedEvent.parameter.actions == 'stopDemoModus') {
	    try {
	        var deviceDSID=Property.getProperty('general/demoDSID');
	        var oDevice=getDevices().byDSID(deviceDSID);
	        if (oDevice!=null) {
	            oDevice.setValue(0);
	        }
	    } catch (e) {
	    }
	    
	    lInfo.log('Stop Demo');    
	    Property.setProperty('general/demoDSID','');
	}
}

